--- //depot/vendor/freebsd/src/sys/netatalk/ddp_usrreq.c	2004/05/05 03:36:28
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_usrreq.c	2004/05/23 16:56:02
@@ -22,6 +22,9 @@
 #include <netatalk/ddp_pcb.h>
 #include <netatalk/at_extern.h>
 
+/*
+ * XXXRW: These structures are currently not mutable.
+ */
 static u_long	ddp_sendspace = DDP_MAXSZ; /* Max ddp size + 1 (ddp_type) */
 static u_long	ddp_recvspace = 10 * (587 + sizeof(struct sockaddr_at));
 
@@ -32,36 +35,38 @@
 {
 	struct ddpcb	*ddp;
 	int		error = 0;
-	int		s;
 	
+	ddp = sotoddpcb(so);
+	if (ddp != NULL)
+		return (EINVAL);
 
-	ddp = sotoddpcb(so);
-	if (ddp != NULL) {
-	    return (EINVAL);
-	}
+	/*
+	 * Allocate socket buffer space first so that it's present
+	 * before first use.
+	 */
+	error = soreserve(so, ddp_sendspace, ddp_recvspace);
+	if (error)
+		return (error);
 
-	s = splnet();
+	DDP_LIST_XLOCK();
 	error = at_pcballoc(so);
-	splx(s);
-	if (error) {
-	    return (error);
-	}
-	return (soreserve(so, ddp_sendspace, ddp_recvspace));
+	DDP_LIST_XUNLOCK();
+	return (error);
 }
 
 static int
 ddp_detach(struct socket *so)
 {
 	struct ddpcb	*ddp;
-	int		s;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
+	if (ddp == NULL)
 	    return (EINVAL);
-	}
-	s = splnet();
+
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
 	at_pcbdetach(so, ddp);
-	splx(s);
+	DDP_LIST_XUNLOCK();
 	return (0);
 }
 
@@ -70,15 +75,16 @@
 {
 	struct ddpcb	*ddp;
 	int		error = 0;
-	int		s;
 	
 	ddp = sotoddpcb(so);
 	if (ddp == NULL) {
 	    return (EINVAL);
 	}
-	s = splnet();
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
 	error = at_pcbsetaddr(ddp, nam, td);
-	splx(s);
+	DDP_UNLOCK(ddp);
+	DDP_LIST_XUNLOCK();
 	return (error);
 }
     
@@ -87,20 +93,23 @@
 {
 	struct ddpcb	*ddp;
 	int		error = 0;
-	int		s;
 	
 	ddp = sotoddpcb(so);
 	if (ddp == NULL) {
 	    return (EINVAL);
 	}
 
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
 	if (ddp->ddp_fsat.sat_port != ATADDR_ANYPORT) {
+	    DDP_UNLOCK(ddp);
+	    DDP_LIST_XUNLOCK();
 	    return (EISCONN);
 	}
 
-	s = splnet();
-	error = at_pcbconnect(ddp, nam, td);
-	splx(s);
+	error = at_pcbconnect( ddp, nam, td );
+	DDP_UNLOCK(ddp);
+	DDP_LIST_XUNLOCK();
 	if (error == 0)
 	    soisconnected(so);
 	return (error);
@@ -111,20 +120,20 @@
 {
 
 	struct ddpcb	*ddp;
-	int		s;
 	
 	ddp = sotoddpcb(so);
 	if (ddp == NULL) {
 	    return (EINVAL);
 	}
+	DDP_LOCK(ddp);
 	if (ddp->ddp_fsat.sat_addr.s_node == ATADDR_ANYNODE) {
+	    DDP_UNLOCK(ddp);
 	    return (ENOTCONN);
 	}
 
-	s = splnet();
 	at_pcbdisconnect(ddp);
 	ddp->ddp_fsat.sat_addr.s_node = ATADDR_ANYNODE;
-	splx(s);
+	DDP_UNLOCK(ddp);
 	soisdisconnected(so);
 	return (0);
 }
@@ -142,13 +151,19 @@
 	return (0);
 }
 
+/*
+ * XXXRW: If an explicit address is specified, then we temporarily change
+ * the address on the pcb for sending.  This is inefficient because it
+ * requires us to perform global rather than pcb-local operations.  It
+ * may also create a race if other users of the socket are simultaneously
+ * sending.
+ */
 static int
 ddp_send(struct socket *so, int flags, struct mbuf *m, struct sockaddr *addr,
             struct mbuf *control, struct thread *td)
 {
 	struct ddpcb	*ddp;
 	int		error = 0;
-	int		s;
 	
 	ddp = sotoddpcb(so);
 	if (ddp == NULL) {
@@ -160,28 +175,29 @@
     	}
 
 	if (addr != NULL) {
+		DDP_LIST_XLOCK();
+		DDP_LOCK(ddp);
 		if (ddp->ddp_fsat.sat_port != ATADDR_ANYPORT) {
-			return (EISCONN);
+			error = EISCONN;
+			goto out;
 		}
 
-		s = splnet();
 		error = at_pcbconnect(ddp, addr, td);
-		splx(s);
-		if (error) {
-			return (error);
+		if (error == 0) {
+			error = ddp_output(m, so);
+			at_pcbdisconnect(ddp);
 		}
+out:
+		DDP_UNLOCK(ddp);
+		DDP_LIST_XUNLOCK();
 	} else {
-		if (ddp->ddp_fsat.sat_port == ATADDR_ANYPORT) {
-			return (ENOTCONN);
-		}
+		DDP_LOCK(ddp);
+		if (ddp->ddp_fsat.sat_port == ATADDR_ANYPORT)
+			error = ENOTCONN;
+		else
+			error = ddp_output(m, so);
+		DDP_UNLOCK(ddp);
 	}
-
-	s = splnet();
-	error = ddp_output(m, so);
-	if (addr != NULL) {
-	    at_pcbdisconnect(ddp);
-	}
-	splx(s);
 	return (error);
 }
 
@@ -189,28 +205,28 @@
 ddp_abort(struct socket *so)
 {
 	struct ddpcb	*ddp;
-	int		s;
 	
 	ddp = sotoddpcb(so);
 	if (ddp == NULL) {
 		return (EINVAL);
 	}
-	s = splnet();
+	DDP_LIST_XLOCK();
+	DDP_LOCK(ddp);
 	at_pcbdetach(so, ddp);
-	splx(s);
+	DDP_LIST_XUNLOCK();
 	return (0);
 }
 
 void 
 ddp_init(void)
 {
-
 	atintrq1.ifq_maxlen = IFQ_MAXLEN;
 	atintrq2.ifq_maxlen = IFQ_MAXLEN;
 	aarpintrq.ifq_maxlen = IFQ_MAXLEN;
 	mtx_init(&atintrq1.ifq_mtx, "at1_inq", NULL, MTX_DEF);
 	mtx_init(&atintrq2.ifq_mtx, "at2_inq", NULL, MTX_DEF);
 	mtx_init(&aarpintrq.ifq_mtx, "aarp_inq", NULL, MTX_DEF);
+	DDP_LIST_LOCK_INIT();
 	netisr_register(NETISR_ATALK1, at1intr, &atintrq1, 0);
 	netisr_register(NETISR_ATALK2, at2intr, &atintrq2, 0);
 	netisr_register(NETISR_AARP, aarpintr, &aarpintrq, 0);
@@ -225,6 +241,7 @@
     for (ddp = ddpcb_list; ddp != NULL; ddp = ddp->ddp_next) {
 	at_pcbdetach(ddp->ddp_socket, ddp);
     }
+    DDP_LIST_LOCK_DESTROY();
 }
 #endif
 
@@ -243,7 +260,9 @@
 	if (ddp == NULL) {
 	    return (EINVAL);
 	}
+	DDP_LOCK(ddp);
 	at_sockaddr(ddp, nam);
+	DDP_UNLOCK(ddp);
 	return (0);
 }
 
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_var.h	2004/03/22 04:56:26
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_var.h	2004/03/22 05:14:09
@@ -13,6 +13,7 @@
     struct socket	*ddp_socket;
     struct ddpcb	*ddp_prev, *ddp_next;
     struct ddpcb	*ddp_pprev, *ddp_pnext;
+    struct mtx		 ddp_mtx;
 };
 
 #define sotoddpcb(so)	((struct ddpcb *)(so)->so_pcb)
@@ -34,5 +35,6 @@
 extern int	ddp_cksum;
 extern struct ddpcb		*ddpcb_list;
 extern struct pr_usrreqs	ddp_usrreqs;
+extern struct mtx		 ddp_list_mtx;
 #endif
 #endif /* _NETATALK_DDP_VAR_H_ */
--- //depot/vendor/freebsd/src/sys/netgraph/bluetooth/socket/ng_btsocket_rfcomm.c	2004/06/14 18:20:38
+++ //depot/user/rwatson/netperf/sys/netgraph/bluetooth/socket/ng_btsocket_rfcomm.c	2004/06/14 19:35:13
@@ -997,8 +997,12 @@
 			/* Close L2CAP socket */
 			s->l2so->so_upcallarg = NULL;
 			s->l2so->so_upcall = NULL;
+			SOCKBUF_LOCK(&s->l2so->so_rcv);
 			s->l2so->so_rcv.sb_flags &= ~SB_UPCALL;
+			SOCKBUF_UNLOCK(&s->l2so->so_rcv);
+			SOCKBUF_LOCK(&s->l2so->so_snd);
 			s->l2so->so_snd.sb_flags &= ~SB_UPCALL;
+			SOCKBUF_UNLOCK(&s->l2so->so_snd);
 			soclose(s->l2so);
 
 			mtx_unlock(&s->session_mtx);
@@ -1237,8 +1241,12 @@
 	/* Prepare L2CAP socket */
 	l2so->so_upcallarg = NULL;
 	l2so->so_upcall = ng_btsocket_rfcomm_upcall;
+	SOCKBUF_LOCK(&l2so->so_rcv);
 	l2so->so_rcv.sb_flags |= SB_UPCALL;
+	SOCKBUF_UNLOCK(&l2so->so_rcv);
+	SOCKBUF_LOCK(&l2so->so_snd);
 	l2so->so_snd.sb_flags |= SB_UPCALL;
+	SOCKBUF_UNLOCK(&l2so->so_snd);
 	l2so->so_state |= SS_NBIO;
 	s->l2so = l2so;
 
@@ -1317,8 +1325,12 @@
 	/* Return L2CAP socket back to its original state */
 	l2so->so_upcallarg = NULL;
 	l2so->so_upcall = NULL;
+	SOCKBUF_LOCK(&l2so->so_rcv);
 	l2so->so_rcv.sb_flags &= ~SB_UPCALL;
+	SOCKBUF_LOCK(&l2so->so_rcv);
+	SOCKBUF_LOCK(&l2so->so_snd);
 	l2so->so_snd.sb_flags &= ~SB_UPCALL;
+	SOCKBUF_LOCK(&l2so->so_snd);
 	l2so->so_state &= ~SS_NBIO;
 
 	mtx_destroy(&s->session_mtx);
--- //depot/vendor/freebsd/src/sys/netgraph/ng_base.c	2004/05/29 07:25:30
+++ //depot/user/rwatson/netperf/sys/netgraph/ng_base.c	2004/05/31 01:41:33
@@ -170,6 +170,7 @@
 #define NG_IDHASH_FN(ID) ((ID) % (NG_ID_HASH_SIZE))
 #define NG_IDHASH_FIND(ID, node)					\
 	do { 								\
+		mtx_assert(&ng_idhash_mtx, MA_OWNED);			\
 		LIST_FOREACH(node, &ng_ID_hash[NG_IDHASH_FN(ID)],	\
 						nd_idnodes) {		\
 			if (NG_NODE_IS_VALID(node)			\
@@ -3231,10 +3232,12 @@
 {
 	node_p node;
 	int i = 1;
+	mtx_lock(&ng_nodelist_mtx);
 	SLIST_FOREACH(node, &ng_allnodes, nd_all) {
 		printf("[%d] ", i++);
 		dumpnode(node, NULL, 0);
 	}
+	mtx_unlock(&ng_nodelist_mtx);
 }
 
 static void
@@ -3242,10 +3245,12 @@
 {
 	hook_p hook;
 	int i = 1;
+	mtx_lock(&ng_nodelist_mtx);
 	SLIST_FOREACH(hook, &ng_allhooks, hk_all) {
 		printf("[%d] ", i++);
 		dumphook(hook, NULL, 0);
 	}
+	mtx_unlock(&ng_nodelist_mtx);
 }
 
 static int
--- //depot/vendor/freebsd/src/sys/netgraph/ng_ksocket.c	2004/06/14 18:20:38
+++ //depot/user/rwatson/netperf/sys/netgraph/ng_ksocket.c	2004/06/14 19:35:13
@@ -609,9 +609,15 @@
 	/* Add our hook for incoming data and other events */
 	priv->so->so_upcallarg = (caddr_t)node;
 	priv->so->so_upcall = ng_ksocket_incoming;
+	SOCKBUF_LOCK(&priv->so->so_rcv);
 	priv->so->so_rcv.sb_flags |= SB_UPCALL;
+	SOCKBUF_UNLOCK(&priv->so->so_rcv);
+	SOCKBUF_LOCK(&priv->so->so_snd);
 	priv->so->so_snd.sb_flags |= SB_UPCALL;
+	SOCKBUF_UNLOCK(&priv->so->so_snd);
+	SOCK_LOCK(priv->so);
 	priv->so->so_state |= SS_NBIO;
+	SOCK_UNLOCK(priv->so);
 	/*
 	 * --Original comment--
 	 * On a cloned socket we may have already received one or more
@@ -941,8 +947,12 @@
 	/* Close our socket (if any) */
 	if (priv->so != NULL) {
 		priv->so->so_upcall = NULL;
+		SOCKBUF_LOCK(&priv->so->so_rcv);
 		priv->so->so_rcv.sb_flags &= ~SB_UPCALL;
+		SOCKBUF_UNLOCK(&priv->so->so_rcv);
+		SOCKBUF_LOCK(&priv->so->so_snd);
 		priv->so->so_snd.sb_flags &= ~SB_UPCALL;
+		SOCKBUF_UNLOCK(&priv->so->so_snd);
 		soclose(priv->so);
 		priv->so = NULL;
 	}
@@ -1003,6 +1013,9 @@
  * before dereferencing the socket pointer.
  */
 
+/*
+ * XXXRW: ng_ksocket_incoming() is called without Giant.  Is that OK?
+ */
 static void
 ng_ksocket_incoming(struct socket *so, void *arg, int waitflag)
 {
@@ -1257,8 +1270,12 @@
 
 	so->so_upcallarg = (caddr_t)node;
 	so->so_upcall = ng_ksocket_incoming;
+	SOCKBUF_LOCK(&so->so_rcv);
 	so->so_rcv.sb_flags |= SB_UPCALL;
+	SOCKBUF_UNLOCK(&so->so_rcv);
+	SOCKBUF_LOCK(&so->so_snd);
 	so->so_snd.sb_flags |= SB_UPCALL;
+	SOCKBUF_UNLOCK(&so->so_snd);
 
 	/* Fill in the response data and send it or return it to the caller */
 	resp_data = (struct ng_ksocket_accept *)resp->data;
--- //depot/vendor/freebsd/src/sys/netgraph/ng_socket.c	2004/05/29 00:56:26
+++ //depot/user/rwatson/netperf/sys/netgraph/ng_socket.c	2004/05/31 01:41:33
@@ -151,6 +151,9 @@
 SYSCTL_INT(_net_graph, OID_AUTO, recvspace, CTLFLAG_RW,
     &ngpdg_recvspace , 0, "Maximum space for incoming Netgraph datagrams");
 
+/*
+ * XXXRW: Locking?
+ */
 /* List of all sockets */
 static LIST_HEAD(, ngpcb) ngsocklist;
 
--- //depot/vendor/freebsd/src/sys/netinet/accf_http.c	2004/06/14 18:20:38
+++ //depot/user/rwatson/netperf/sys/netinet/accf_http.c	2004/06/14 19:35:13
@@ -161,6 +161,7 @@
 sohashttpget(struct socket *so, void *arg, int waitflag)
 {
 
+	/* Unlocked read. */
 	if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) == 0 && !sbfull(&so->so_rcv)) {
 		struct mbuf *m;
 		char *cmp;
@@ -214,6 +215,7 @@
 	struct mbuf *m, *n;
 	int	i, cc, spaces, inspaces;
 
+	/* Unlocked read. */
 	if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) != 0 || sbfull(&so->so_rcv))
 		goto fallout;
 
@@ -301,6 +303,7 @@
 	int ccleft, copied;
 
 	DPRINT("start");
+	/* Unlocked read. */
 	if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) != 0 || sbfull(&so->so_rcv))
 		goto gotit;
 
--- //depot/vendor/freebsd/src/sys/netinet/if_ether.c	2004/06/13 10:56:09
+++ //depot/user/rwatson/netperf/sys/netinet/if_ether.c	2004/06/13 20:00:27
@@ -98,6 +98,11 @@
 #define la_timer la_rt->rt_rmx.rmx_expire /* deletion time in seconds */
 };
 
+/*
+ * XXXRW: Need to document (and/or fix) locking for this.  We always
+ * seem to hold a lock (and assert) when referencing this list, but it's
+ * not clear it's always the same lock.
+ */
 static	LIST_HEAD(, llinfo_arp) llinfo_arp;
 
 static struct	ifqueue arpintrq;
--- //depot/vendor/freebsd/src/sys/netinet/igmp.c	2004/06/11 03:45:34
+++ //depot/user/rwatson/netperf/sys/netinet/igmp.c	2004/06/11 13:24:13
@@ -99,6 +99,9 @@
 static u_long igmp_all_hosts_group;
 static u_long igmp_all_rtrs_group;
 
+/*
+ * XXXRW: These variables make me vaguely nervous.
+ */
 static struct mbuf *router_alert;
 static struct route igmprt;
 
@@ -123,6 +126,7 @@
 
 	/*
 	 * Construct a Router Alert option to use in outgoing packets
+	 * XXXRW: This might actually need a MAC label.
 	 */
 	MGET(router_alert, M_DONTWAIT, MT_DATA);
 	ra = mtod(router_alert, struct ipoption *);
--- //depot/vendor/freebsd/src/sys/netinet/in_gif.c	2004/04/14 01:15:27
+++ //depot/user/rwatson/netperf/sys/netinet/in_gif.c	2004/04/17 01:57:58
@@ -174,6 +174,9 @@
 	}
 	bcopy(&iphdr, mtod(m, struct ip *), sizeof(struct ip));
 
+	/*
+	 * XXXRW: locking of gif's softc.
+	 */
 	if (dst->sin_family != sin_dst->sin_family ||
 	    dst->sin_addr.s_addr != sin_dst->sin_addr.s_addr) {
 		/* cache route doesn't match */
@@ -320,6 +323,10 @@
 	case 0: case 127: case 255:
 		return 0;
 	}
+
+	/*
+	 * XXXRW: Lock in_ifaddrhead walking.
+	 */
 	/* reject packets with broadcast on source */
 	TAILQ_FOREACH(ia4, &in_ifaddrhead, ia_link) {
 		if ((ia4->ia_ifa.ifa_ifp->if_flags & IFF_BROADCAST) == 0)
@@ -328,6 +335,7 @@
 			return 0;
 	}
 
+	/* XXXRW: unlocked read. */
 	/* ingress filters on outer source */
 	if ((sc->gif_if.if_flags & IFF_LINK2) == 0 && ifp) {
 		struct sockaddr_in sin;
@@ -383,6 +391,11 @@
 in_gif_attach(sc)
 	struct gif_softc *sc;
 {
+	
+	/*
+	 * XXXRW: Technically, NULL can also be returned for ENOMEM,
+	 * not just EEXIST.
+	 */
 	sc->encap_cookie4 = encap_attach_func(AF_INET, -1, gif_encapcheck,
 	    &in_gif_protosw, sc);
 	if (sc->encap_cookie4 == NULL)
--- //depot/vendor/freebsd/src/sys/netinet/in_pcb.c	2004/06/13 02:50:44
+++ //depot/user/rwatson/netperf/sys/netinet/in_pcb.c	2004/06/13 04:03:52
@@ -673,6 +673,7 @@
 #ifdef IPSEC
 	ipsec_pcbdisconn(inp->inp_sp);
 #endif
+	/* Unlocked read. */
 	if (inp->inp_socket->so_state & SS_NOFDREF)
 		in_pcbdetach(inp);
 }
--- //depot/vendor/freebsd/src/sys/netinet/in_pcb.h	2004/04/07 20:52:05
+++ //depot/user/rwatson/netperf/sys/netinet/in_pcb.h	2004/04/08 03:11:34
@@ -244,9 +244,14 @@
 #define INP_LOCK(inp)		mtx_lock(&(inp)->inp_mtx)
 #define INP_UNLOCK(inp)		mtx_unlock(&(inp)->inp_mtx)
 #ifndef INET6
-#define INP_LOCK_ASSERT(inp)	mtx_assert(&(inp)->inp_mtx, MA_OWNED)
+#define INP_LOCK_ASSERT(inp)	do {					\
+	mtx_assert(&(inp)->inp_mtx, MA_OWNED);				\
+	NET_ASSERT_GIANT();						\
+} while (0)
 #else
-#define INP_LOCK_ASSERT(inp)
+#define INP_LOCK_ASSERT(inp)	do {					\
+	NET_ASSERT_GIANT();						\
+} while (0)
 #endif
 
 #define INP_INFO_LOCK_INIT(ipi, d) \
@@ -256,11 +261,21 @@
 #define INP_INFO_RUNLOCK(ipi)	mtx_unlock(&(ipi)->ipi_mtx)
 #define INP_INFO_WUNLOCK(ipi)	mtx_unlock(&(ipi)->ipi_mtx)
 #ifndef INET6
-#define INP_INFO_RLOCK_ASSERT(ipi)	mtx_assert(&(ipi)->ipi_mtx, MA_OWNED)
-#define INP_INFO_WLOCK_ASSERT(ipi)	mtx_assert(&(ipi)->ipi_mtx, MA_OWNED)
+#define INP_INFO_RLOCK_ASSERT(ipi)	do {				\
+	mtx_assert(&(ipi)->ipi_mtx, MA_OWNED);				\
+	NET_ASSERT_GIANT();						\
+} while (0)
+#define INP_INFO_WLOCK_ASSERT(ipi)	do {				\
+	mtx_assert(&(ipi)->ipi_mtx, MA_OWNED);				\
+	NET_ASSERT_GIANT();						\
+} while (0)
 #else
-#define INP_INFO_RLOCK_ASSERT(ipi)
-#define INP_INFO_WLOCK_ASSERT(ipi)
+#define INP_INFO_RLOCK_ASSERT(ipi)	do {				\
+	NET_ASSERT_GIANT();						\
+} while (0)
+#define INP_INFO_WLOCK_ASSERT(ipi)	do {				\
+	NET_ASSERT_GIANT();						\
+} while (0)
 #endif
 
 #define INP_PCBHASH(faddr, lport, fport, mask) \
--- //depot/vendor/freebsd/src/sys/netinet/ip_divert.c	2004/06/13 02:50:44
+++ //depot/user/rwatson/netperf/sys/netinet/ip_divert.c	2004/06/13 04:03:52
@@ -262,12 +262,6 @@
 
 	KASSERT(m->m_pkthdr.rcvif == NULL, ("rcvif not null"));
 
-#ifdef MAC
-	SOCK_LOCK(so);
-	mac_create_mbuf_from_socket(so, m);
-	SOCK_UNLOCK(so);
-#endif
-
 	if (control)
 		m_freem(control);		/* XXX */
 
@@ -324,6 +318,9 @@
 			/* Send packet to output processing */
 			ipstat.ips_rawout++;			/* XXX */
 
+#ifdef MAC
+			mac_create_mbuf_from_inpcb(inp, m);
+#endif
 			error = ip_output(m,
 				    inp->inp_options, NULL,
 				    (so->so_options & SO_DONTROUTE) |
@@ -350,6 +347,14 @@
 			}
 			m->m_pkthdr.rcvif = ifa->ifa_ifp;
 		}
+#ifdef MAC
+		/*
+		 * XXXRW: perhaps should be mac_create_mbuf_from_inpcb()?
+		 */
+		SOCK_LOCK(so);
+		mac_create_mbuf_from_socket(so, m);
+		SOCK_UNLOCK(so);
+#endif
 		/* Send packet to input processing */
 		ip_input(m);
 	}
@@ -417,6 +422,7 @@
 	/* The socket is always "connected" because
 	   we always know "where" to send the packet */
 	INP_UNLOCK(inp);
+	/* XXXRW: so_state locking. */
 	so->so_state |= SS_ISCONNECTED;
 	return 0;
 }
@@ -459,6 +465,8 @@
 static int
 div_disconnect(struct socket *so)
 {
+
+	/* Unlocked read. */
 	if ((so->so_state & SS_ISCONNECTED) == 0)
 		return ENOTCONN;
 	return div_abort(so);
--- //depot/vendor/freebsd/src/sys/netinet/ip_dummynet.c	2004/03/03 01:35:21
+++ //depot/user/rwatson/netperf/sys/netinet/ip_dummynet.c	2004/03/04 04:00:06
@@ -171,7 +171,10 @@
 #define	DUMMYNET_LOCK_DESTROY()	mtx_destroy(&dummynet_mtx)
 #define	DUMMYNET_LOCK()		mtx_lock(&dummynet_mtx)
 #define	DUMMYNET_UNLOCK()	mtx_unlock(&dummynet_mtx)
-#define	DUMMYNET_LOCK_ASSERT()	mtx_assert(&dummynet_mtx, MA_OWNED)
+#define	DUMMYNET_LOCK_ASSERT()	do {				\
+	mtx_assert(&dummynet_mtx, MA_OWNED);			\
+	NET_ASSERT_GIANT();					\
+} while (0)
 
 static int config_pipe(struct dn_pipe *p);
 static int ip_dn_ctl(struct sockopt *sopt);
--- //depot/vendor/freebsd/src/sys/netinet/ip_encap.c	2004/03/10 02:50:38
+++ //depot/user/rwatson/netperf/sys/netinet/ip_encap.c	2004/03/10 03:47:45
@@ -1,4 +1,4 @@
-/*	$FreeBSD: src/sys/netinet/ip_encap.c,v 1.19 2004/03/10 02:48:50 rwatson Exp $	*/
+/*	$FreeBSD: src/sys/netinet/ip_encap.c,v 1.18 2003/06/01 09:20:38 phk Exp $	*/
 /*	$KAME: ip_encap.c,v 1.41 2001/03/15 08:35:08 itojun Exp $	*/
 
 /*
@@ -106,8 +106,7 @@
 LIST_HEAD(, encaptab) encaptab = LIST_HEAD_INITIALIZER(&encaptab);
 
 /*
- * We currently keey encap_init() for source code compatibility reasons --
- * it's referenced by KAME pieces in netinet6.
+ * XXXRW: encap_init() was entirely useless, so I deleted it.
  */
 void
 encap_init()
@@ -185,6 +184,10 @@
 	}
 	mtx_unlock(&encapmtx);
 
+	/*
+	 * XXXRW: Need drain mechanism to prevent the encapsulation
+	 * entry from being released while in use.
+	 */
 	if (match) {
 		/* found a match, "match" has the best one */
 		psw = match->psw;
@@ -255,6 +258,10 @@
 	}
 	mtx_unlock(&encapmtx);
 
+	/*
+	 * XXXRW: Need drain mechanism so the encap entry isn't freed
+	 * while in use.
+	 */
 	if (match) {
 		/* found a match */
 		psw = (const struct ip6protosw *)match->psw;
--- //depot/vendor/freebsd/src/sys/netinet/ip_encap.h	2002/03/19 21:30:39
+++ //depot/user/rwatson/netperf/sys/netinet/ip_encap.h	2004/03/12 06:46:13
@@ -35,6 +35,15 @@
 
 #ifdef _KERNEL
 
+/*
+ * This structure is entirely static after registration, and other than
+ * its entry in the encapsulation table, requires no locking.  The chain
+ * field is locked using the global encapmtx.
+ *
+ * XXXRW: Need to add a refcount/drain mechanism so that encapsulation
+ * entries can't be removed while in use.  This likely requires a
+ * refcount and cv to wait for it to drain, or an sx lock.
+ */
 struct encaptab {
 	LIST_ENTRY(encaptab) chain;
 	int af;
--- //depot/vendor/freebsd/src/sys/netinet/ip_fastfwd.c	2004/05/06 18:50:39
+++ //depot/user/rwatson/netperf/sys/netinet/ip_fastfwd.c	2004/05/23 16:56:02
@@ -644,6 +644,7 @@
 				/*
 				 * Return packet for processing by ip_input
 				 */
+				/* XXX statistic */
 				if (ro.ro_rt)
 					RTFREE(ro.ro_rt);
 				return 0;
--- //depot/vendor/freebsd/src/sys/netinet/ip_fw2.c	2004/06/11 22:20:41
+++ //depot/user/rwatson/netperf/sys/netinet/ip_fw2.c	2004/06/12 17:06:18
@@ -136,7 +136,10 @@
 #define	IPFW_LOCK_DESTROY(_chain)	mtx_destroy(&(_chain)->mtx)
 #define	IPFW_LOCK(_chain)	mtx_lock(&(_chain)->mtx)
 #define	IPFW_UNLOCK(_chain)	mtx_unlock(&(_chain)->mtx)
-#define	IPFW_LOCK_ASSERT(_chain)	mtx_assert(&(_chain)->mtx, MA_OWNED)
+#define	IPFW_LOCK_ASSERT(_chain)	do {				\
+	mtx_assert(&(_chain)->mtx, MA_OWNED);				\
+	NET_ASSERT_GIANT();						\
+} while (0)
 
 /*
  * list of rules for layer 3
@@ -1538,7 +1541,8 @@
 }
 
 static int
-check_uidgid(ipfw_insn_u32 *insn,
+check_uidgid(struct ip_fw_chain *chain,
+	ipfw_insn_u32 *insn,
 	int proto, struct ifnet *oif,
 	struct in_addr dst_ip, u_int16_t dst_port,
 	struct in_addr src_ip, u_int16_t src_port,
@@ -1568,7 +1572,9 @@
 		return 0;
 	match = 0;
 	if (*lookup == 0) {
+		IPFW_UNLOCK(chain);
 		INP_INFO_RLOCK(pi);	/* XXX LOR with IPFW */
+		IPFW_LOCK(chain);
 		pcb =  (oif) ?
 			in_pcblookup_hash(pi,
 				dst_ip, htons(dst_port),
@@ -1933,7 +1939,7 @@
 					break;
 				if (proto == IPPROTO_TCP ||
 				    proto == IPPROTO_UDP)
-					match = check_uidgid(
+					match = check_uidgid(chain,
 						    (ipfw_insn_u32 *)cmd,
 						    proto, oif,
 						    dst_ip, dst_port,
--- //depot/vendor/freebsd/src/sys/netinet/ip_id.c	2004/02/26 03:55:40
+++ //depot/user/rwatson/netperf/sys/netinet/ip_id.c	2004/03/12 03:03:57
@@ -79,6 +79,9 @@
 	2729
 };
 
+/*
+ * XXXRW: Locking?
+ */
 static u_int16_t ru_x;
 static u_int16_t ru_seed, ru_seed2;
 static u_int16_t ru_a, ru_b;
--- //depot/vendor/freebsd/src/sys/netinet/ip_input.c	2004/06/13 17:30:39
+++ //depot/user/rwatson/netperf/sys/netinet/ip_input.c	2004/06/13 20:00:27
@@ -937,8 +937,10 @@
 		/* attach next hop info for TCP */
 		struct m_tag *mtag = m_tag_get(PACKET_TAG_IPFORWARD,
 		    sizeof(struct sockaddr_in *), M_NOWAIT);
-		if (mtag == NULL)
+		if (mtag == NULL) {
+			/* XXX statistic */
 			goto bad;
+		}
 		*(struct sockaddr_in **)(mtag+1) = args.next_hop;
 		m_tag_prepend(m, mtag);
 	}
@@ -1869,6 +1871,7 @@
 		struct m_tag *mtag = m_tag_get(PACKET_TAG_IPFORWARD,
 		    sizeof(struct sockaddr_in *), M_NOWAIT);
 		if (mtag == NULL) {
+			/* XXX statistic */
 			m_freem(m);
 			return;
 		}
--- //depot/vendor/freebsd/src/sys/netinet/ip_mroute.c	2004/05/30 20:25:31
+++ //depot/user/rwatson/netperf/sys/netinet/ip_mroute.c	2004/05/31 01:41:33
@@ -104,7 +104,10 @@
 static struct mtx mfc_mtx;
 #define	MFC_LOCK()	mtx_lock(&mfc_mtx)
 #define	MFC_UNLOCK()	mtx_unlock(&mfc_mtx)
-#define	MFC_LOCK_ASSERT()	mtx_assert(&mfc_mtx, MA_OWNED)
+#define	MFC_LOCK_ASSERT()	do {					\
+	mtx_assert(&mfc_mtx, MA_OWNED);					\
+	NET_ASSERT_GIANT();						\
+} while (0)
 #define	MFC_LOCK_INIT()	mtx_init(&mfc_mtx, "mroute mfc table", NULL, MTX_DEF)
 #define	MFC_LOCK_DESTROY()	mtx_destroy(&mfc_mtx)
 
@@ -1304,13 +1307,10 @@
 socket_send(struct socket *s, struct mbuf *mm, struct sockaddr_in *src)
 {
     if (s) {
-	mtx_lock(&Giant);		/* XXX until sockets are locked */
 	if (sbappendaddr(&s->so_rcv, (struct sockaddr *)src, mm, NULL) != 0) {
 	    sorwakeup(s);
-	    mtx_unlock(&Giant);
 	    return 0;
 	}
-	mtx_unlock(&Giant);
     }
     m_freem(mm);
     return -1;
--- //depot/vendor/freebsd/src/sys/netinet/ip_output.c	2004/06/13 17:30:39
+++ //depot/user/rwatson/netperf/sys/netinet/ip_output.c	2004/06/13 20:00:27
@@ -157,6 +157,12 @@
 
 	M_ASSERTPKTHDR(m);
 	
+	/*
+	 * When packet comes from dummynet restore state from
+	 * previous processing instead of the header.  Yech!
+	 *
+	 * XXX add conditional compilation?
+	 */
 	args.next_hop = m_claim_next(m, PACKET_TAG_IPFORWARD);
 	dummytag = m_tag_find(m, PACKET_TAG_DUMMYNET, NULL);
 	if (dummytag != NULL) {
@@ -878,6 +884,7 @@
 				    PACKET_TAG_IPFORWARD,
 				    sizeof(struct sockaddr_in *), M_NOWAIT);
 				if (mtag == NULL) {
+					/* XXX statistic */
 					error = ENOBUFS;
 					goto bad;
 				}
@@ -896,6 +903,7 @@
 				    CSUM_IP_CHECKED | CSUM_IP_VALID;
 				ip->ip_len = htons(ip->ip_len);
 				ip->ip_off = htons(ip->ip_off);
+				/* XXX netisr_queue(NETISR_IP, m); */
 				ip_input(m);
 				goto done;
 			}
--- //depot/vendor/freebsd/src/sys/netinet/raw_ip.c	2004/06/09 20:10:43
+++ //depot/user/rwatson/netperf/sys/netinet/raw_ip.c	2004/06/10 22:28:54
@@ -87,6 +87,9 @@
  * so leave them not initialized and rely on BSS being set to 0.
  */
 
+/*
+ * XXXRW: Locking for mrouter bits?
+ */
 /* The socket used to communicate with the multicast routing daemon.  */
 struct socket  *ip_mrouter;
 
@@ -628,6 +631,7 @@
 	}
 	INP_LOCK(inp);
 	soisdisconnected(so);
+	/* Unlocked read. */
 	if (so->so_state & SS_NOFDREF)
 		rip_pcbdetach(so, inp);
 	else
@@ -639,6 +643,8 @@
 static int
 rip_disconnect(struct socket *so)
 {
+
+	/* Unlocked read. */
 	if ((so->so_state & SS_ISCONNECTED) == 0)
 		return ENOTCONN;
 	return rip_abort(so);
@@ -735,6 +741,7 @@
 
 	INP_INFO_WLOCK(&ripcbinfo);
 	inp = sotoinpcb(so);
+	/* Unlocked read. */
 	if (so->so_state & SS_ISCONNECTED) {
 		if (nam) {
 			INP_INFO_WUNLOCK(&ripcbinfo);
--- //depot/vendor/freebsd/src/sys/netinet/tcp_debug.c	2004/04/07 20:52:05
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_debug.c	2004/04/08 03:11:34
@@ -50,6 +50,7 @@
 #include <sys/systm.h>
 #include <sys/mbuf.h>
 #include <sys/protosw.h>
+#include <sys/mbuf.h>
 #include <sys/socket.h>
 
 #include <netinet/in.h>
--- //depot/vendor/freebsd/src/sys/netinet/tcp_input.c	2004/06/15 03:56:17
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_input.c	2004/06/15 04:00:58
@@ -355,6 +355,7 @@
 		flags = q->tqe_th->th_flags & TH_FIN;
 		nq = LIST_NEXT(q, tqe_q);
 		LIST_REMOVE(q, tqe_q);
+		/* Unlocked read. */
 		if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
 			m_freem(q->tqe_m);
 		else
@@ -424,7 +425,7 @@
 	struct tcpopt to;		/* options in this segment */
 	struct rmxp_tao tao;		/* our TAO cache entry */
 	int headlocked = 0;
-	struct sockaddr_in *next_hop = NULL;
+	struct sockaddr_in *next_hop;
 	int rstreason; /* For badport_bandlim accounting purposes */
 
 	struct ip6_hdr *ip6 = NULL;
@@ -747,6 +748,7 @@
 		tiwin = th->th_win;
 
 #ifdef MAC
+	INP_LOCK_ASSERT(inp);
 	if (mac_check_inpcb_deliver(inp, m))
 		goto drop;
 #endif
@@ -1162,6 +1164,7 @@
 				acked = th->th_ack - tp->snd_una;
 				tcpstat.tcps_rcvackpack++;
 				tcpstat.tcps_rcvackbyte += acked;
+				SOCKBUF_LOCK(&so->so_snd);
 				sbdrop(&so->so_snd, acked);
 				if (SEQ_GT(tp->snd_una, tp->snd_recover) &&
 				    SEQ_LEQ(th->th_ack, tp->snd_recover))
@@ -1199,7 +1202,9 @@
 						      tp->t_rxtcur,
 						      tcp_timer_rexmt, tp);
 
-				sowwakeup(so);
+				sowwakeup_locked(so);
+				SOCKBUF_UNLOCK(&so->so_snd);
+				/* Unlocked read. */
 				if (so->so_snd.sb_cc)
 					(void) tcp_output(tp);
 				goto check_delack;
@@ -1237,6 +1242,7 @@
 #endif
 			 * Add data to socket buffer.
 			 */
+			/* Unlocked read. */
 			if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
 				m_freem(m);
 			} else {
@@ -1709,6 +1715,7 @@
 	 * If new data are received on a connection after the
 	 * user processes are gone, then RST the other end.
 	 */
+	/* Unlocked read. */
 	if ((so->so_state & SS_NOFDREF) &&
 	    tp->t_state > TCPS_CLOSE_WAIT && tlen) {
 		tp = tcp_close(tp);
@@ -2101,6 +2108,7 @@
 				incr = incr * incr / cw;
 			tp->snd_cwnd = min(cw+incr, TCP_MAXWIN<<tp->snd_scale);
 		}
+		SOCKBUF_LOCK(&so->so_snd);
 		if (acked > so->so_snd.sb_cc) {
 			tp->snd_wnd -= so->so_snd.sb_cc;
 			sbdrop(&so->so_snd, (int)so->so_snd.sb_cc);
@@ -2110,7 +2118,8 @@
 			tp->snd_wnd -= acked;
 			ourfinisacked = 0;
 		}
-		sowwakeup(so);
+		sowwakeup_locked(so);
+		SOCKBUF_UNLOCK(&so->so_snd);
 		/* detect una wraparound */
 		if (tcp_do_newreno && !IN_FASTRECOVERY(tp) &&
 		    SEQ_GT(tp->snd_una, tp->snd_recover) &&
@@ -2143,6 +2152,7 @@
 		 * we should release the tp also, and use a
 		 * compressed state.
 		 */
+				/* Unlocked read. */
 				if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
 					soisdisconnected(so);
 					callout_reset(tp->tt_2msl, tcp_maxidle,
@@ -2226,6 +2236,7 @@
 		 * soreceive.  It's hard to imagine someone
 		 * actually wanting to send this much urgent data.
 		 */
+		/* Unlocked read. */
 		if (th->th_urp + so->so_rcv.sb_cc > sb_max) {
 			th->th_urp = 0;			/* XXX */
 			thflags &= ~TH_URG;		/* XXX */
@@ -2245,6 +2256,8 @@
 		 * of data past the urgent section as the original
 		 * spec states (in one of two places).
 		 */
+		/* Unlocked read of sb_cc. */
+		/* XXXRW: Unlocked assignment of so_oobmark, sb_state. */
 		if (SEQ_GT(th->th_seq+th->th_urp, tp->rcv_up)) {
 			tp->rcv_up = th->th_seq + th->th_urp;
 			so->so_oobmark = so->so_rcv.sb_cc +
@@ -2314,6 +2327,7 @@
 			tcpstat.tcps_rcvpack++;
 			tcpstat.tcps_rcvbyte += tlen;
 			ND6_HINT(tp);
+			/* Unlocked read. */
 			if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
 				m_freem(m);
 			else
@@ -2940,6 +2954,10 @@
 	}
 	tp->t_maxseg = mss;
 
+	/*
+	 * XXXRW: read-modify-write on socket buffer without acquiring
+	 * the socket buffer lock.
+	 */
 	if ((so->so_rcv.sb_hiwat == tcp_recvspace) && metrics.rmx_recvpipe)
 		bufsize = metrics.rmx_recvpipe;
 	else
--- //depot/vendor/freebsd/src/sys/netinet/tcp_output.c	2004/05/04 02:15:32
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_output.c	2004/05/04 02:32:28
@@ -210,6 +210,7 @@
 			 * to send then the probe will be the FIN
 			 * itself.
 			 */
+			/* Unlocked read of sb_cc. */
 			if (off < so->so_snd.sb_cc)
 				flags &= ~TH_FIN;
 			sendwin = 1;
@@ -231,6 +232,7 @@
 	 * be set to snd_una, the offset will be 0, and the length may
 	 * wind up 0.
 	 */
+	/* Unlocked read of sb_cc. */
 	len = (long)ulmin(so->so_snd.sb_cc, sendwin) - off;
 
 
@@ -292,6 +294,7 @@
 		len = tp->t_maxseg;
 		sendalot = 1;
 	}
+	/* Unlocked read of sb_cc. */
 	if (SEQ_LT(tp->snd_nxt + len, tp->snd_una + so->so_snd.sb_cc))
 		flags &= ~TH_FIN;
 
@@ -319,6 +322,7 @@
 		 *
 		 * note: the len + off check is almost certainly unnecessary.
 		 */
+		/* Unlocked read of sb_cc. */
 		if (!(tp->t_flags & TF_MORETOCOME) &&	/* normal case */
 		    (idle || (tp->t_flags & TF_NODELAY)) &&
 		    len + off >= so->so_snd.sb_cc &&
@@ -397,6 +401,7 @@
 	 * if window is nonzero, transmit what we can,
 	 * otherwise force out a byte.
 	 */
+	/* Unlocked read of sb_cc. */
 	if (so->so_snd.sb_cc && !callout_active(tp->tt_rexmt) &&
 	    !callout_active(tp->tt_persist)) {
 		tp->t_rxtshift = 0;
@@ -664,6 +669,7 @@
 		 * give data to the user when a buffer fills or
 		 * a PUSH comes in.)
 		 */
+		/* Unlocked read of sb_cc. */
 		if (off + len == so->so_snd.sb_cc)
 			flags |= TH_PUSH;
 	} else {
--- //depot/vendor/freebsd/src/sys/netinet/tcp_subr.c	2004/06/12 20:50:42
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_subr.c	2004/06/12 21:17:12
@@ -576,6 +576,7 @@
 #ifdef INET6
 	int isipv6 = (inp->inp_vflag & INP_IPV6) != 0;
 #endif /* INET6 */
+	int callout_flag;
 
 	tm = uma_zalloc(tcpcb_zone, M_NOWAIT | M_ZERO);
 	if (tm == NULL)
@@ -589,11 +590,17 @@
 		tcp_mssdflt;
 
 	/* Set up our timeouts. */
-	callout_init(tp->tt_rexmt = &tm->tcpcb_mem_rexmt, 0);
-	callout_init(tp->tt_persist = &tm->tcpcb_mem_persist, 0);
-	callout_init(tp->tt_keep = &tm->tcpcb_mem_keep, 0);
-	callout_init(tp->tt_2msl = &tm->tcpcb_mem_2msl, 0);
-	callout_init(tp->tt_delack = &tm->tcpcb_mem_delack, 0);
+	/*
+	 * XXXRW: Are these actually MPSAFE?  I think so, but need to
+	 * review the timed wait code, as it has some list variables,
+	 * etc, that are global.
+	 */
+	callout_flag = debug_mpsafenet ? CALLOUT_MPSAFE : 0;
+	callout_init(tp->tt_rexmt = &tm->tcpcb_mem_rexmt, callout_flag);
+	callout_init(tp->tt_persist = &tm->tcpcb_mem_persist, callout_flag);
+	callout_init(tp->tt_keep = &tm->tcpcb_mem_keep, callout_flag);
+	callout_init(tp->tt_2msl = &tm->tcpcb_mem_2msl, callout_flag);
+	callout_init(tp->tt_delack = &tm->tcpcb_mem_delack, callout_flag);
 
 	if (tcp_do_rfc1323)
 		tp->t_flags = (TF_REQ_SCALE|TF_REQ_TSTMP);
@@ -1595,7 +1602,7 @@
 
 /*
  * Move a TCP connection into TIME_WAIT state.
- *    tcbinfo is unlocked.
+ *    tcbinfo is locked.
  *    inp is locked, and is unlocked before returning.
  */
 void
@@ -1607,6 +1614,11 @@
 	int tw_time, acknow;
 	struct socket *so;
 
+	INP_INFO_WLOCK_ASSERT(&tcbinfo);
+#if 0
+	INP_LOCK_ASSERT(tp);
+#endif
+
 	tw = uma_zalloc(tcptw_zone, M_NOWAIT);
 	if (tw == NULL) {
 		tw = tcp_timer_2msl_tw(1);
@@ -1740,6 +1752,8 @@
 	int isipv6 = inp->inp_inc.inc_isipv6;
 #endif
 
+	INP_LOCK_ASSERT(inp);
+
 	m = m_gethdr(M_DONTWAIT, MT_HEADER);
 	if (m == NULL)
 		return (ENOBUFS);
